#!/sbin/sh

# configure.sh by SuperR. @XDA

# Do not edit this file unless you know what you are doing

rm -f /tmp/config

# Get slot if it exists
SLOT=$(getprop ro.boot.slot_suffix)
if [ -z $SLOT ]; then
	SLOT=_$(getprop ro.boot.slot)
	if [ $SLOT = "_" ]; then
		SLOT=
	fi
fi
if [ -z $SLOT ]; then
	SLOT=$(cat /proc/cmdline 2>/dev/null | tr ' ' '\n' | grep slot | grep -v simslot | cut -d'=' -f2)
fi
if [ ! -z $SLOT ]; then
	if [ $SLOT = "_a" || $SLOT = "_b" ]; then
		echo "slotnum=$SLOT" >> /tmp/config
	else
		SLOT=
	fi
fi

# Get system partition and by-name paths
SYSTEMBLOCK=$(find /dev/block | grep -i "system$SLOT" | head -n 1)
if [ -z $SYSTEMBLOCK ]; then
	for i in /etc/*fstab*; do
		SYSTEMBLOCK=$(grep -v '#' $i | grep -E '/system[^a-zA-Z]' | grep -v system_image | grep -v mmcblk | grep -oE '/dev/[a-zA-Z0-9_./-]*')
		if [ ! -z $SYSTEMBLOCK ]; then
			break
		fi
	done
fi
if [ ! -z $SYSTEMBLOCK ] && [ $(readlink -f $SYSTEMBLOCK) ]; then
	BYNAME=$(dirname $SYSTEMBLOCK)
	echo "byname=$BYNAME" >> /tmp/config
else
	echo "fail=fail" >> /tmp/config
	exit 1
fi

# Check for system_root mount point
if [ -d /system_root ]; then
	echo "sysmnt=/system_root" >> /tmp/config
else
	echo "sysmnt=/system" >> /tmp/config
fi

# Add verified partitions to /tmp/config
for i in system SYSTEM APP; do
	if [ $(readlink $BYNAME/$i$SLOT) ]; then
		echo "system=$BYNAME/$i$SLOT" >> /tmp/config
		break
	fi
done
for i in vendor VENDOR VNR; do
	if [ $(readlink $BYNAME/$i$SLOT) ]; then
		echo "vendor=$BYNAME/$i$SLOT" >> /tmp/config
		break
	fi
done
for i in userdata USERDATA UDA; do
	if [ $(readlink $BYNAME/$i$SLOT) ]; then
		echo "data=$BYNAME/$i$SLOT" >> /tmp/config
		break
	fi
done
for i in boot BOOT LNX; do
	if [ $(readlink $BYNAME/$i$SLOT) ]; then
		echo "boot=$BYNAME/$i$SLOT" >> /tmp/config
		break
	fi
done
for i in version product cust oem odm ODM recovery RECOVERY ramdisk RAMDISK kernel KERNEL Kernel; do
	if [ $(readlink $BYNAME/$i$SLOT) ]; then
		echo "$(tr '[:upper:]' '[:lower:]' <<< $i)=$BYNAME/$i$SLOT" >> /tmp/config
	fi
done
